       program     S14CAI
C
C Four-state-carbonic-anhydrase-enzyme-kinetic-scheme (CA-enzyme HCAI)
C CA4 output is CA.dat
C Rate constants and reactants from Berhavan-1990 in
C Carbonic-A-rate-constants-table.docs
C Product P is HCO3, substrate S is CO2
C Buffer B is 50 mM dimethylimidazole/H2SO4 (pH=7.24).
C
C
C       real*8  thermale,rckonst1,rckonst2,
C     &   xsec,sigma,enprodB1,enprodB2,enprodB3,enprodB4,
C     &   k12,k21,k23,k32,k34,k43,k41,k14,
C     &   keqk12,keqk23,keqk34,keqk41,sigmap,sigmab,
C     &   sigmah,sigmaq,currB1,currB2,currB3,currB4,
C     &   keqk3,keqk1,keqk2,keqk4,enprodT,ckonst4a(1000),
C     &   sprob(4),entros(4),entrops,aX1,aX2,aX3,aX4,aX,
C     &   kcat,KMich,Ktot,ENZeff,substrates,ckonst1a(1000),
C     &   s1,s2,pi,ckonst2a(1000),ckonst3a(1000),
C     &   products,gaussrand1,gaussrand2,gaussrand3,
C     &   gaussrand4,gaussrand5,gaussrand6,gaussrand7,gaussrand8
       real*8  ckonst1a(2000),ckonst2a(2000),
     &   thermale,rckonst1,rckonst2,
     &   xsec,sigma,enprodB1,enprodB2,enprodB3,enprodB4,
     &   effic,k12,k21,k23,k32,k34,k43,k41,k14,
     &   keqk12,keqk23,keqk34,keqk41,
     &   sigmap,sigmab,sigmah,sigmaq,
     &   currB1,currB2,currB3,currB4,
     &   ckonst3a(2000),ckonst4a(2000),ckonst5a(2000),
     &   enprodT,s1,s2,gaussrand1,pi,gaussrand2,
     &   sprob(4),entros(4),entrops,ENZeff,
     &   aX1,aX2,aX3,aX4,kcat,aXtot,Ktot,KMich,substrate,GAPproduct,
     &   Jplus,Jminus,Jratio,Kplus,Kminus,Kratio,buffer,gaussrand8,
     &   gaussrand3,gaussrand4,gaussrand5,gaussrand6,gaussrand7
C
       s1=0.0
       s2=0.0
       pi=0.0
       gaussrand1=0.0
       gaussrand2=0.0
       gaussrand3=0.0
       gaussrand4=0.0
       gaussrand5=0.0
       gaussrand6=0.0
       gaussrand7=0.0
       gaussrand8=0.0
       keqk12=0.0
       keqk23=0.0
       keqk34=0.0
       keqk41=0.0
       aX1=0.0
       aX2=0.0
       aX3=0.0
       aX4=0.0
       enprodB3=0.0
       enprodB4=0.0
       enprodB1=0.0
       enprodB2=0.0
       enprodT=0.0
C
       sigmap=0.0
       sigmab=0.0
       sigmah=0.0
       sigmaq=0.0
C
C
       k12=0.0
       k21=0.0
       k23=0.0
       k32=0.0
       k34=0.0
       k43=0.0
       k41=0.0
       k14=0.0
       currB1=0.0
       currB2=0.0
       currB3=0.0
       currB4=0.0
C
C
       thermale=0.0
C
       rckonst1=0.0
       rckonst2=0.0
C
       sigma=0.0
C
       kcat=0.0
       aXtot=0.0
       Ktot=0.0
       KMich=0.0
       ENZeff=0.0
       substrate=0.0
       GAPproduct=0.0
       buffer=0.0
       Jplus=0.0
       Jminus=0.0
       Jratio=0.0
       Kplus=0.0
       Kminus=0.0
       Kratio=0.0
C add:
       mmm=0
C       i=0
       entrops=0.0
C
       nnn=0
       jjj=0
C
C
            open (unit=11,status='unknown',file='S14-CAI-exper.dat',
     & access='sequential',form='formatted')
          write (11,115)
115     format(2x,'     k1           k2           k3             k4 ',
     & '          k5           k6             k7             k8      ',
     & '          X/RT          X           Ktot          J ',
     & '         Ptot        Eff              kcat           P1 ',
     & '          P2              P3          P4             S  ',
     & '         P        B           Km            S(I)',
     & '         p1          p2          p3          p4')
C
C
C
            GAPproduct=0.024
C
            substrate=0.0012
C
            buffer=0.05
C
          k12=34000000.0*substrate
C
         k21=38000.0
C
         k23=290000.0
C
         k32=26000000.0*GAPproduct
C
         k34=900000.0
C
          k43=9000000.0
C
         k41=110000000.0*buffer
C
        k14=900000.0*buffer
C
	   keqk12=k12/k21
	   keqk23=k23/k32
	   keqk34=k34/k43
	   keqk41=k41/k14
C
       Jplus=k12*k23*k34*k41
       Jminus=k21*k32*k43*k14
       Jratio=Jplus/Jminus
       Kplus=Jplus/substrate
CC                 division with the substrate conc. in moles
       Kminus=Jminus/GAPproduct
CC                 division with the product conc. in moles
       Kratio=Kplus/Kminus
C
        thermale=2.478957
C
C in kJ/mol for 25C
C
         pi=3.141592653589793
C

C
       kcat=(k23*k34*k41)/((k23+k32)*(k43+k41)+k23*k34+k34*k41)
C
       Ktot=keqk12*keqk23*keqk34*keqk41
C
       KMich=(k21*(k32*(k43+k41)+k34*k41)+k23*k34*k41)*substrate/
     &       (k12*((k23+k32)*(k43+k41)+k23*k34+k34*k41))
C
        ENZeff=kcat/KMich
C
         sigma=0.0
         sigmab=0.0
         sigmah=0.0
         sigmaq=0.0
         sigmap=0.0
C 4-th state probability added p=1,b=2,h=3,q=4
         entrops=0.0
	   enprodB1=0.0
	   enprodB2=0.0
	   enprodB3=0.0
C sdd 4-th partial entropy production
       enprodB4=0.0
	   enprodT=0.0
CC
           do 75 jj=1,4
         sprob(jj)=0.0
         entros(jj)=0.0
75       continue
C
C
         sigmap=k43*k32*k21+k21*k34*k41+k41*k32*k21+k23*k34*k41
         sigmab=k34*k41*k12+k14*k43*k32+k12*k43*k32+k32*k41*k12
         sigmah=k41*k12*k23+k21*k14*k43+k14*k43*k23+k12*k23*k43
         sigmaq=k32*k21*k14+k12*k23*k34+k14*k23*k34+k21*k14*k34
C
C
         sigma=sigmab+sigmah+sigmaq+sigmap
C
         sigmab=sigmab/sigma
         sigmah=sigmah/sigma
         sigmaq=sigmaq/sigma
         sigmap=sigmap/sigma
C
         sigma=sigmab+sigmah+sigmaq+sigmap
C
         sprob(1)=sigmab
         sprob(2)=sigmah
         sprob(3)=sigmaq
         sprob(4)=sigmap
C
        do 750 mmmm=1,4
          entros(mmmm)=-sprob(mmmm)*2.3*dlog10(sprob(mmmm))
          entrops=entrops+entros(mmmm)
750     continue
C
C
        xsec=thermale*2.3025851*dlog10((k12*k23*k34*k41)/
     & (k21*k32*k43*k14))
Cn all currents are without N (N=1)
Cn
        currB1=(k12*sigmap-k21*sigmab)
        currB2=(k23*sigmab-k32*sigmah)
        currB3=(k34*sigmah-k43*sigmaq)
        currB4=(k41*sigmaq-k14*sigmap)
C
          aX1=2.3025851*dlog10((k12*sigmap)/
     &   (k21*sigmab))
C
          aX2=2.3025851*dlog10((k23*sigmab)/
     &   (k32*sigmah))
C
          aX3=2.3025851*dlog10((k34*sigmah)/
     &   (k43*sigmaq))
C
          aX4=2.3025851*dlog10((k41*sigmaq)/
     &   (k14*sigmap))
C
          aXtot=aX1+aX2+aX3+aX4
C
Cn All "entropy productions" are XJ/RT expressions
Cn
        enprodB1=aX1*currB1
        enprodB2=aX2*currB2
        enprodB3=aX3*currB3
        enprodB4=aX4*currB4
C
        enprodT=enprodB1+enprodB2+enprodB3+enprodB4
C
C These enprod expressions are entropy production divided by the gas const R
        write(11,'(19(1x,f13.4),2x,4(f9.7,2x),1x,5(f12.8,1x))')
     & k12,k21,k23,k32,k34,k43,k41,k14,aXtot,xsec,Ktot,currB1,
     & enprodT,Enzeff,kcat,enprodB1,enprodB2,enprodB3,enprodB4,
     & substrate,GAPproduct,buffer,KMich,entrops,
     & sigmab,sigmah,sigmaq,sigmap
C
C
        open (unit=13,status='unknown',file='S14-CAI-random.dat',
     & access='sequential',form='formatted')
       write(13,65)
65     format(2x,'  i          k1           k2            k3       ',
     &  '         k4           k5            k6               k7    ',
     &  '          k8               X             X/RT          Ktot  ',
     &  '         J            Ptot          Eff            kcat     ',
     &  '        P1            P2              P3             P4   ',
     &  '       S          P          B           K(M)       ',
     &  '     S(I)       p1          p2            p3           p4 ')
C
        do 50 i=1,2000
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand1=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand2=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+1
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand3=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+4
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand4=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand5=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand6=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand7=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand8=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)
C
         if (gaussrand7.gt.0) then
         k41=110000000.0*buffer*gaussrand7
         endif
C
         if (gaussrand8.gt.0) then
         k14=900000.0*buffer*gaussrand8
         keqk41=k41/k14
         endif
C
         if (gaussrand5.gt.0) then
         k34=900000.0*gaussrand5
         endif
C
         if (gaussrand6.gt.0) then
         k43=9000000.0*gaussrand6
         endif
         keqk34=k34/k43
C
         if (gaussrand3.gt.0) then
         k23=290000*gaussrand3
         endif
C
         if (gaussrand4.gt.0) then
         k32=26000000.0*GAPproduct*gaussrand4
         endif
         keqk23=k23/k32
C
         if (gaussrand1.gt.0) then
         k12=34000000.0*substrate*gaussrand1
         endif
C
         if (gaussrand2.gt.0) then
         k21=38000.0*gaussrand2
         endif
         keqk12=k12/k21
C
       kcat=(k23*k34*k41)/((k23+k32)*(k43+k41)+k23*k34+k34*k41)
C
       Ktot=keqk12*keqk23*keqk34*keqk41
C
       KMich=(k21*(k32*(k43+k41)+k34*k41)+k23*k34*k41)*substrate/
     &       (k12*((k23+k32)*(k43+k41)+k23*k34+k34*k41))
C
        ENZeff=kcat/KMich
C
C
         sigma=0.0
         sigmab=0.0
         sigmah=0.0
         sigmaq=0.0
         sigmap=0.0
C 4-th state probability added p=1,b=2,h=3,q=4
         entrops=0.0
	   enprodB1=0.0
	   enprodB2=0.0
	   enprodB3=0.0
C sdd 4-th partial entropy production
       enprodB4=0.0
	   enprodT=0.0
CC         do 55 jj=1,3
           do 55 jj=1,4
         sprob(jj)=0.0
         entros(jj)=0.0
55       continue
C
         sigmap=k43*k32*k21+k21*k34*k41+k41*k32*k21+k23*k34*k41
         sigmab=k34*k41*k12+k14*k43*k32+k12*k43*k32+k32*k41*k12
         sigmah=k41*k12*k23+k21*k14*k43+k14*k43*k23+k12*k23*k43
         sigmaq=k32*k21*k14+k12*k23*k34+k14*k23*k34+k21*k14*k34
C
C
         sigma=sigmab+sigmah+sigmaq+sigmap
C
         sigmab=sigmab/sigma
         sigmah=sigmah/sigma
         sigmaq=sigmaq/sigma
         sigmap=sigmap/sigma
C
         sigma=sigmab+sigmah+sigmaq+sigmap
C
         sprob(1)=sigmab
         sprob(2)=sigmah
         sprob(3)=sigmaq
         sprob(4)=sigmap
C
       do 700 mmmm=1,4
          entros(mmmm)=-sprob(mmmm)*2.3*dlog10(sprob(mmmm))
          entrops=entrops+entros(mmmm)
700    continue
C
C
       xsec=thermale*2.3025851*dlog10((k12*k23*k34*k41)/
     & (k21*k32*k43*k14))
Cn all currents are without N (N=1)
Cn
        currB1=(k12*sigmap-k21*sigmab)
        currB2=(k23*sigmab-k32*sigmah)
        currB3=(k34*sigmah-k43*sigmaq)
        currB4=(k41*sigmaq-k14*sigmap)
C
          aX1=2.3025851*dlog10((k12*sigmap)/
     &   (k21*sigmab))
C
          aX2=2.3025851*dlog10((k23*sigmab)/
     &   (k32*sigmah))
C
          aX3=2.3025851*dlog10((k34*sigmah)/
     &   (k43*sigmaq))
C
          aX4=2.3025851*dlog10((k41*sigmaq)/
     &   (k14*sigmap))
C
          aXtot=aX1+aX2+aX3+aX4
C
        enprodB1=aX1*currB1
        enprodB2=aX2*currB2
        enprodB3=aX3*currB3
        enprodB4=aX4*currB4
C
        enprodT=enprodB1+enprodB2+enprodB3+enprodB4
C
C These enprod expressions are entropy production divided by the gas const R
C
       write(13,'(i5,2x,19(1x,f14.4),2x,4(f9.7,2x),1x,5(f12.8,1x))')
     & i,k12,k21,k23,k32,k34,k43,k41,k14,aXtot,xsec,Ktot,currB1,
     & enprodT,Enzeff,kcat,enprodB1,enprodB2,enprodB3,enprodB4,
     & substrate,GAPproduct,buffer,KMich,
     & entrops,sigmab,sigmah,sigmaq,sigmap
C
50    continue
C
250     continue
C
C
       stop
       end
C Author: Davor Juretic, year:2023, preprint:
C Computational Improvements of Enzyme Efficiency kcat/KM by Increasing Noise and Dissipation
C Submitted to the Entropy journal.
C Title: Theoretical Improvements in Enzyme Efficiency Associated with Noisy Rate Constants and Increased Dissipation
C
C We used the columns from S14-CAI-random.dat enprodT (named Ptot) and ENZeff (named Eff)
C to create figure S7 from the Supplementary Material.
C The run time should be around 2.0 sec.

