;
; carbonic anhydrase I (Behravan-1990) with buffer in moles and S(CO2), P(H2CO3) conc in moles from Wilhelm-Heinrich-1994
; interface conc are in micromoles. These values are divided by 1000000 in the code to produce results in moles
globals [
 substrate-added
  enzymes-added
  Efree
  Sfree
  Pfree
  substrates-init
  products-init
  enzymes-init
;  buffer
  k1
  k8
  k8*var
  k4*var
  k1*var
  k7
  k7*
  k7*var
  k4*
  k7exp
  k8exp
  k4exp
  k2exp
  k6exp
  k6var
  k4var
  k5
  k6
  k4
  k3
  k2
  Keq4*
  Keq1*
  Keq2*
  Keq1
  Keq2
  Keq3
  Keq4
  KeqTOT
  GAMA
  FORCE
  val
 kcat
 Km
 enzeff
 p1N
 p2N
 p3N
 p4N
 p1
 p2
 p3
 p4
 pallD
 currB1
 currB2
 currB3
 currB4
 xsec
 aX1
 aX2
 aX3
 aX4
 aXtot
 dissB1
 dissB2
 dissB3
 dissB4
 dissTOT
 dissTOTexp
 all-dissB4-list
 entropy
  CEtot
  CSPtot
  table
  headers
]

breed [ enzymes enzyme ]
breed [substrates substrate ]
breed [ products product ]
breed [buffers buffer]
breed [ESenzymes ESenzyme]
breed [EZenzymes EZenzyme]
breed [EXenzymes EXenzyme]

turtles-own [
  partner
  turtle-list
]
extensions [ csv ]
to setup
  clear-all
;
  file-close-all
;
  clear-turtles
  set substrate-added 0
  set kcat 0
;
  add enzymes proteins
;
  add products initprod
  add substrates volume   ; in micromoles/10 Wilhelm-Heinrich-1994
  set enzymes-init proteins
  set substrates-init volume
  set products-init initprod   ; in micromoles/10 Wilhem-Heinrich-1994
;
  clear-all-plots
  reset-ticks
;
end

to add [ kind amount ]
  create-turtles amount
   [ set breed kind
      setxy random-xcor random-ycor
      set partner nobody
      setshape ]
  if kind = substrates
    [ set substrate-added substrate-added + amount ]
end
;
to setshape
  ifelse breed = enzymes
  [ set color red
     ifelse partner = nobody
        [ set shape "enzyme" ]
         [ if ([breed] of (partner) = substrates)
         [ set shape "ESenzyme" ] ] ]
   [if breed = substrates
      [ set color green
          set shape "substrate"
      set hidden? (partner != nobody) ] ]
;
   ifelse breed = enzymes
   [ set color red
     ifelse partner = nobody
        [ set shape "enzyme" ]
         [ if ([breed] of (partner) = products)
        [ set shape "EPenzyme" ] ] ]
;
            [ if breed = products
                [ set color yellow
                  set shape "product"
                  set hidden? false ] ]
        if breed = EXenzymes
         [set shape "EXenzyme" ]
end
; the main procedure for the E+S to ES to EX to EZ to E cycling
;
to go
;
    if (ticks = 5520)
    [ stop ]
  if ticks < 1
    [ calculate-velocity ]
  if ticks > 0
  [ ask turtles [ move ]
;
;
  ask enzymes [ form-ES-from-E-and-S ]
;
    ask enzymes [ form-EZ-from-E-and-B ]
;
     ask EXenzymes [form-EZ]
;
    ask EXenzymes [form-ES-from-EX-and-P]
;
    ask EZenzymes [form-EX]
  ask ESenzymes [dissociate]
    ask substrates [react-forward]
  ask ESenzymes [form-EX-from-ES]
;
    ask EZenzymes [form-E-from-EZ-and-B]
;
;
    calculate-velocity-for-nonzero-ticks ]
;
   if ticks < 1
  ; data output into one column text file
      [ file-open "S15-CAI-exper-performance.txt"
      file-print ("ticks")
      file-show ticks
      file-print ("dissTOT")
      file-show dissTOT
      file-print ("dissB4")
      file-show dissB4
      file-print ("dissB3")
      file-show dissB3
      file-print ("dissB2")
      file-show dissB2
      file-print ("dissB1")
      file-show dissB1
      file-print ("kcat")
      file-show kcat
      file-print ("K(M)")
      file-show Km
      file-print ("eff")
      file-show enzeff
      file-print ("J4")
      file-show currB4
      file-print ("J1")
      file-show currB1
      file-print ("K1")
      file-show Keq1
      file-print ("K2")
      file-show Keq2
      file-print ("K3")
      file-show Keq3
      file-print ("K4")
      file-show Keq4
      file-print ("Xtot")
      file-show FORCE
      file-print ("xsec")
      file-show xsec
      file-print ("X1")
      file-show aX1
      file-print ("X2")
      file-show aX2
      file-print ("X3")
      file-show aX3
      file-print ("X4")
      file-show aX4
      file-print ("S")
      file-show entropy
      file-print ("products#")
      file-show count products
      file-print ("k8 microM")
        file-show k8
      file-print ("substrates")
      file-show count substrates
      file-print ("k1 microM")
      file-show k1
      file-print ("k2")
      file-show k2
      file-print ("k3")
      file-show k3
      file-print ("k4")
      file-show k4
      file-print ("k5")
      file-show k5
      file-print ("k6")
      file-show k6
      file-print ("k7")
      file-show k7exp
      file-print ("k8 microM")
      file-show k8
      file-print ("p1")
      file-show p1
      file-print ("p2")
      file-show p2
      file-print ("p3")
      file-show p3
      file-print ("p4")
      file-show p4
        file-print ("........")
        file-close ]
;
            if ticks >= 0
;    data output into the CSV file with 44 columns easily converted into xlsx file
;
      [file-open "S15-CAI.csv"
    if ticks < 1
    [file-print csv:to-row ["tick"
      "J"
      "kcat"
      "Eff"
      "Ptot"
      "P1"
      "P2"
      "P3"
      "P4"
      "p1"
      "p2"
      "p3"
      "p4"
      "K1"
      "K2"
      "K3"
      "K4"
      "k1"
      "k2"
      "k3"
      "k4"
      "k5"
      "k6"
      "k7"
      "k8"
      "X"
      "X1"
      "X2"
      "X3"
      "X4"
      "S(I)"
      "Km"
      "Etot"
      "SPtot"
      "Efree"
      "Sfree"
      "Pfree"
      "ES"
      "EX"
      "EZ"
      "GAMA"
      "K"
      "FORCE"
;
    ]]
;
     if ticks >= 0
 [
           file-print csv:to-row (list ticks currB1 kcat enzeff dissTOT dissB1 dissB2 dissB3 dissB4 p1 p2 p3 p4
           Keq1 Keq2 Keq3 Keq4 k1 k2 k3 k4 k5 k6 k7 k8 Xsec aX1 aX2 aX3 aX4 entropy Km CEtot CSPtot Efree Sfree Pfree
       count ESenzymes count EXenzymes count EZenzymes GAMA KeqTOT FORCE)
;
      file-close ]]
 ; ]
 ;   tick
; end
;
    tick
end
;
to move
;
    fd 1
    rt random-float 360
end
;
to form-ES-from-E-and-S
  if partner != nobody [ stop ]
 ;
  if partner = nobody and Efree > 0
;
  [ set partner one-of (other substrates-here with [partner = nobody])
;
   let k1* 34000000.0
;
  if (any? other substrates-here) and
     random-float 1000 < k1*
;
   [ ask enzymes-here
     [ setshape
      set breed ESenzymes
      set shape "ESenzyme" ]
     set partner nobody
      ask substrates-here [die]]]
 ;
end
;
to dissociate
   set k2 38000.0
  if count ESenzymes > 0
  [ if partner != nobody
    [ if ([breed] of partner = substrates) and (random-float 1000 < k2)
      [ ask partner [ set partner nobody ]
     let old-partner partner
     set partner nobody
;
        set breed substrates
        set shape "substrate"
         ask ESenzymes-here
          [ set breed enzymes
            set shape "enzyme" ]
        ask old-partner [ setshape ] ] ] ]
end
;
to form-EZ
   set k5 900000.0
;
    if (any? other EXenzymes-here) and
     random-float 1000 < k5
     [ set breed EZenzymes
      set shape "EPenzyme" ]
end

to react-forward
  set k3 290000.0
 ;
   if count ESenzymes > 0
  [if (partner = substrates) and (random-float 1000 < k3)
    [ set breed products
      set shape "product"
      ask ESenzymes-here
      [ set breed EXenzymes
        set shape "EXenzyme"]]]
end
;
to form-EX-from-ES
  set k3 290000.0
;
    if (any? other ESenzymes-here) and random-float 1000 < k3
;
     [ set breed EXenzymes
       set shape "EXenzyme"]
;
end

to form-ES-from-EX-and-P
;
  if count EXenzymes > 0
;
    [set partner one-of (other enzymes-here with [partner = nobody])
  if partner = nobody [ stop ]
;
    set k4* 26000000.0
  if [partner] of partner != nobody [ set partner nobody stop ]
;
    ifelse ((([breed] of partner) = products) and ((random-float 1000) < k4*))
    [ ask partner [ set partner myself ]
    set breed ESenzymes
    set shape "ESenzyme"
    ask partner [ setshape ] ]
    [ set partner nobody ]
  ask products-here [die]]
end
;
;
to form-EX
;
    set k6 9000000.0
;
  if (any? other EZenzymes-here) and
     random-float 1000 < k6
     [ set breed EXenzymes
    set shape "EXenzyme"  ]
end
;
to form-E-from-EZ-and-B
;
    if count EZenzymes > 0
;
    [set partner one-of (other enzymes-here with [partner = nobody])
  if partner = nobody [ stop ]
 ;
    set k7* 110000000.0
  if [partner] of partner != nobody [ set partner nobody stop ]
;
    ifelse ((([breed] of partner) = buffers) and ((random-float 1000) < k7*))
    [ ask partner [ set partner myself ]
    set breed enzymes
    set shape "enzyme"
    ask partner [ setshape ] ]
    [ set partner nobody ]]
end
;
to form-EZ-from-E-and-B
;
  if Efree > 0
;
    [set partner one-of (other enzymes-here with [partner = nobody])
  if partner = nobody [ stop ]
;
    let k8* 900000.0
  if [partner] of partner != nobody [ set partner nobody stop ]
;
    ifelse ((([breed] of partner) = buffers) and ((random-float 1000) < k8*))
    [ ask partner [ set partner myself ]
    set breed EZenzymes
    set shape "EPenzyme"
    ask partner [ setshape ] ]
    [ set partner nobody ]]
end
;
to calculate-velocity
; observed values for rate constants in moles are used and all results should agree with calculated exper. values
  if ticks < 1
;
    [let k1* 34000000.0
  set k2 38000.0
  set k3 290000.0
;
    set k4* 26000000.0
  set k4 26000000.0 * (count products / 100000)
  set k5 900000.0
  set k6 9000000.0
  set k7 110000000.0 * (5000.0 / 100000)
;
  let k8* 900000.0
  let thermale 2.4361
;
    set k1 k1* * (count substrates / 100000)
    set k8 k8* * (5000.0 / 100000)
;
     set Keq4* k7 / k8*
;
    set Keq1* k1* / k2
    set Keq2* k3 / k4*
    set Keq1 k1 / k2
    set Keq2 k3 / k4
    set Keq3 k5 / k6
    set Keq4 k7 / k8
    set KeqTOT Keq1* * Keq2* * Keq3 * Keq4*
    set GAMA count products / count substrates
;
    set FORCE  (thermale * ln ( GAMA / KeqTOT))
   set kcat (k3 * k5 * k7) / (k5 * k7 + k3 * k5 + (k3 + k4) * (k6 + k7))
;
     set Km (k3 * k5 * k7 + k2 * (k5 * k7 + k4 * (k6 + k7)))/
      ( k1* * (k5 * k7 + k5 * k3 + (k3 + k4) * (k6 + k7)))
;
     set enzeff kcat / Km
      set p1N k6 * k4 * k2 + k7 * (k2 * k5 + k4 * k2 + k3 * k5)
      set p2N k5 * k7 * k1 + k8 * k6 * k4 + k1 * k6 * k4 + k4 * k7 * k1
      set p3N k7 * k1 * k3 + k2 * k8 * k6 + k8 * k6 * k3 + k1 * k3 * k6
      set p4N  k1 * k3 * k5 + ( k3 * k5 + k2 * k5 + k4 * k2) * k8
      set pallD p1N + p2N + p3N + p4N
      set p1 p1N / pallD
      set p2 p2N / pallD
      set p3 p3N / pallD
      set p4 p4N / pallD
       set currB1 k1 * p1 - k2 * p2
       set currB2 k3 * p2 - k4 * p3
       set currB3 k5 * p3 - k6 * p4
       set currB4 k7 * p4 - k8 * p1
;
       set xsec ln (( k1 * k3 * k5 * k7 ) / ( k2 * k4 * k6 * k8 ))
       set aX1 ln (( k1 * p1 ) / ( k2 * p2 ))
       set aX2 ln (( k3 * p2 ) / ( k4 * p3 ))
       set aX3 ln (( k5 * p3 ) / ( k6 * p4 ))
       set aX4 ln (( k7 * p4 ) / ( k8 * p1 ))
       set aXtot aX1 + aX2 + aX3 + aX4  ; should be identical to xsec
         set dissB1 aX1 * currB1
         set dissB2 aX2 * currB2
         set dissB3 aX3 * currB3
         set dissB4 aX4 * currB4
         set dissTOT dissB1 + dissB2 + dissB3 + dissB4
         set dissTOTexp dissTOT
    set entropy (( p1 * ln p1 + p2 * ln p2 + p3 * ln p3 + p4 * ln p4) * (-1))
 ;
    set Efree enzymes-init - count ESenzymes - count EZenzymes - count EXenzymes
    set CEtot Efree + count ESenzymes + count EXenzymes + count EZenzymes
    set Pfree count products with [partner = nobody]
    set Sfree substrates-init + products-init - count ESenzymes - count EZenzymes
        - count EXenzymes - Pfree
    set CSPtot Sfree + Pfree + count ESenzymes + count EXenzymes + count EZenzymes
;
  ]
end
to calculate-velocity-for-nonzero-ticks
; random nuber generator extract any rate constant value between lower and random-float limit
  if ticks > 0
  [
    file-open "S15-CAI.csv"
    set Efree enzymes-init - count ESenzymes - count EZenzymes - count EXenzymes
    set CEtot Efree + count ESenzymes + count EXenzymes + count EZenzymes
    set Pfree count products with [partner = nobody]
    set Sfree substrates-init + products-init - count ESenzymes - count EZenzymes
        - count EXenzymes - Pfree
    set CSPtot Sfree + Pfree + count ESenzymes + count EXenzymes + count EZenzymes
;
    let thermale 2.4361
    let k1* 34000000.0
  set k2exp 38000.0
  set k3 290000.0
  set k4* 26000000.0
  set k4exp 26000000.0 * (count products / 100000)
  set k5 900000.0
  set k6exp 9000000.0
  set k7* 110000000.0
  set k7exp 110000000.0 * (5000.0 / 100000)
  let k8* 900000.0
  set k8exp k8* * (5000.0 / 100000)
;
     let  gaussrand1 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
;
    set k1*var 34000000.0 * gaussrand1
;
    set k1 k1*var * (Sfree / 100000)
;
     let s1 random-float 1.0
     let s2 random-float 1.0
    let  gaussrand sqrt(-2 * ln (s1)) * cos (2 * pi * s2)
    let  gaussrand8 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k8*var 900000.0 * gaussrand8
      set k8 k8*var * (5000.0 / 100000)
 ;
    let  gaussrand7 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k7*var 110000000.0 * gaussrand7
     set k7 k7*var * (5000.0 / 100000)
    set Keq4 K7 / k8
    let gaussrand2 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
     set k2 38000.0 * gaussrand2
     set Keq1 k1 / k2
     set Keq4* k7exp / k8*
;
    set Keq1* k1* / k2exp
;
    let  gaussrand6 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k6var 9000000.0 * gaussrand6
    set k6 k6var
    let  gaussrand5 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k5 900000.0 * gaussrand5
    set Keq3 k5 / k6
;
    let  gaussrand4 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k4*var 26000000.0 * gaussrand4
    set k4 k4*var * (Pfree / 100000)
;
    let  gaussrand3 sqrt(-2 * ln (random-float 1.0)) * cos (2 * pi * random-float 1.0)
    set k3 290000.0 * gaussrand3
    set Keq2 k3 / k4
    set Keq2* k3 / k4*
;
    set KeqTOT Keq1* * Keq2* * Keq3 * Keq4*
;
    set GAMA Pfree / Sfree
    set FORCE  (thermale * ln ( GAMA / KeqTOT))
;
     set kcat (k3 * k5 * k7) / (k5 * k7 + k3 * k5 + (k3 + k4) * (k6 + k7))
;
     set Km (k3 * k5 * k7 + k2 * (k5 * k7 + k4 * (k6 + k7))) / ( k1*var * (k5 * k7 + k5 * k3 + (k3 + k4) * (k6 + k7)))
;
     set enzeff kcat / Km
      set p1N k6 * k4 * k2 + k7 * (k2 * k5 + k4 * k2 + k3 * k5)
      set p2N k5 * k7 * k1 + k8 * k6 * k4 + k1 * k6 * k4 + k4 * k7 * k1
      set p3N k7 * k1 * k3 + k2 * k8 * k6 + k8 * k6 * k3 + k1 * k3 * k6
      set p4N  k1 * k3 * k5 + ( k3 * k5 + k2 * k5 + k4 * k2) * k8
      set pallD p1N + p2N + p3N + p4N
      set p1 p1N / pallD
      set p2 p2N / pallD
      set p3 p3N / pallD
      set p4 p4N / pallD
       set currB1 k1 * p1 - k2 * p2
       set currB2 k3 * p2 - k4 * p3
       set currB3 k5 * p3 - k6 * p4
       set currB4 k7 * p4 - k8 * p1
;
; when RT=thermale is omitted, the dissipation RP is expressed as entropy production P devided by R  (in inverse seconds)
       set xsec ln (( k1 * k3 * k5 * k7 ) / ( k2 * k4 * k6 * k8 ))
       set aX1 ln (( k1 * p1 ) / ( k2 * p2 ))
       set aX2 ln (( k3 * p2 ) / ( k4 * p3 ))
       set aX3 ln (( k5 * p3 ) / ( k6 * p4 ))
       set aX4 ln (( k7 * p4 ) / ( k8 * p1 ))
       set aXtot aX1 + aX2 + aX3 + aX4  ; should be identical to xsec
         set dissB1 aX1 * currB1
         set dissB2 aX2 * currB2
         set dissB3 aX3 * currB3
         set dissB4 aX4 * currB4
         set dissTOT dissB1 + dissB2 + dissB3 + dissB4
        set entropy (( p1 * ln p1 + p2 * ln p2 + p3 * ln p3 + p4 * ln p4) * (-1))
;
    file-close

;              file-open "myFile.csv"
;           file-print csv:to-row (list ticks currB1 kcat enzeff dissTOT dissB1 dissB2 dissB3 dissB4 p1 p2 p3 p4
;           Keq1 Keq2 Keq3 Keq4 k1 k2 k3 k4 k5 k6 k7 k8 Xsec aX1 aX2 aX3 aX4 entropy Km CEtot CSPtot Efree Sfree Pfree
;       count ESenzymes count EZenzymes count EPenzymes s1 s2 gaussrand)
;      file-close
  ]
;
;
;
;
end
;
;  Author: Davor Juretic, year:2023, preprint:
;  Computational Improvements of Enzyme Efficiency kcat/KM by Increasing Noise and Dissipation
;  Submitted to the Entropy journal in January 2024 with the title:
;  Theoretical Improvements in Enzyme Efficiency Associated with Noisy Rate Constants and Increased Dissipation
;
;  Inspired by Uri Wilensky "Enzyme Kinetics" in 2001
;  Our NetLogo source code is based on the simulation „Enzyme Kinetics“
;  (Stieff and Wilensky: https://ccl.northwestern.edu/netlogo/models/EnzymeKinetics)
;  of the traditional Michaelis-Menten model for reversible E+S↔ES transition and irreversible complex dissociation ES→E+P.
;  We extended it to all reversible transitions among 4
;  functionally important carbonic anhydrase I conformational states.
@#$#@#$#@
GRAPHICS-WINDOW
210
10
1034
419
-1
-1
16.0
1
10
1
1
1
0
1
1
1
-25
25
-12
12
1
1
1
ticks
30.0

BUTTON
30
42
97
75
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
41
113
104
146
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
25
16
200
49
volume
volume
0
120
120.0
1
1
micromoles/10
HORIZONTAL

PLOT
15
323
215
473
Concentrations
time
C
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"ES-conf" 1.0 0 -13290229 true "" "plot count ESenzymes"
"EZ-conf" 1.0 0 -7858858 true "" "plot count EZenzymes"
"EX-conf" 1.0 0 -13345367 true "" "plot count EXenzymes"
"Sfree" 1.0 0 -7500403 true "" "plot Sfree / 100"
"Efree" 1.0 0 -2674135 true "" "Plot Efree"
"Pfree" 1.0 0 -955883 true "" "plot Pfree / 100"

MONITOR
1075
127
1137
172
enzymes
count enzymes
0
1
11

MONITOR
1064
77
1136
122
substrates
count substrates
0
1
11

MONITOR
1066
249
1128
294
products
count products
0
1
11

SLIDER
20
487
192
520
proteins
proteins
1
100
100.0
1
1
NIL
HORIZONTAL

MONITOR
1068
310
1125
355
ES-conf
count ESenzymes
0
1
11

MONITOR
1069
370
1126
415
EZ-conf
count EZenzymes
0
1
11

MONITOR
1061
18
1118
63
turtles
count turtles
0
1
11

MONITOR
1136
311
1193
356
EZ-conf
count EZenzymes
0
1
11

MONITOR
24
169
136
214
catalytic constant
kcat
3
1
11

MONITOR
26
230
120
275
m-m-constant
Km
6
1
11

SWITCH
1068
202
1171
235
pause?
pause?
1
1
-1000

SLIDER
19
84
201
117
initprod
initprod
0
2400
2400.0
1
1
micromoles/10
HORIZONTAL

MONITOR
19
274
131
319
enzyme efficiency
enzeff
2
1
11

MONITOR
7
536
64
581
p1
p1
4
1
11

MONITOR
69
536
126
581
p2
p2
4
1
11

MONITOR
6
586
63
631
p3
p3
4
1
11

MONITOR
68
583
125
628
p4
p4
4
1
11

MONITOR
1068
423
1125
468
J1
currB1
3
1
11

MONITOR
1065
471
1122
516
J2
currB2
3
1
11

MONITOR
1131
423
1188
468
J3
currB3
3
1
11

MONITOR
1130
472
1187
517
J4
currB4
3
1
11

MONITOR
1141
252
1198
297
tot X
aXtot
4
1
11

MONITOR
1134
375
1192
420
entropy
entropy
5
1
11

MONITOR
1054
537
1206
582
total dissipation
dissTOT
5
1
11

MONITOR
1127
21
1186
66
K-equilib
KeqTOT
6
1
11

MONITOR
1143
79
1200
124
GAMA
GAMA
6
1
11

MONITOR
1147
129
1204
174
FORCE
FORCE
4
1
11

MONITOR
1213
380
1270
425
dissB1
dissB1
3
1
11

MONITOR
1212
431
1269
476
dissB2
dissB2
3
1
11

MONITOR
1216
483
1273
528
dissB3
dissB3
3
1
11

MONITOR
1216
530
1273
575
dissB4
dissB4
3
1
11

MONITOR
1224
254
1312
299
k7 rate const
k7
2
1
11

MONITOR
1219
313
1307
358
k8 microM
k8
3
1
11

MONITOR
1197
204
1254
249
xsec
xsec
4
1
11

MONITOR
706
447
777
492
k1 microM
k1
3
1
11

MONITOR
704
506
775
551
k2
k2
3
1
11

MONITOR
1195
21
1252
66
K1*
Keq1*
5
1
11

MONITOR
1259
23
1316
68
K2
Keq2
5
1
11

MONITOR
1208
81
1265
126
K3
Keq3
5
1
11

MONITOR
1270
82
1327
127
K4*
Keq4*
5
1
11

MONITOR
1210
135
1267
180
Xtot
aXtot
4
1
11

MONITOR
1271
137
1328
182
X4
aX4
4
1
11

MONITOR
709
566
766
611
Efree
Efree
1
1
11

MONITOR
144
535
201
580
Pfree
Pfree
1
1
11

MONITOR
146
589
203
634
Sfree
Sfree
1
1
11

PLOT
229
433
429
583
Eff-Ptot
Ptot
Eff
0.0
200000.0
0.0
1.0E7
true
false
"" ""
PENS
"default" 1.0 2 -16777216 true "" "plotxy dissTOT enzeff"

MONITOR
810
444
867
489
k3
k3
5
1
11

MONITOR
812
511
869
556
k4
k4
5
1
11

MONITOR
902
444
959
489
k5
k5
5
1
11

MONITOR
900
512
957
557
k6
k6
5
1
11

SLIDER
228
588
413
621
initbuffer
initbuffer
0
5000
5000.0
1
1
micromoles/10
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

ESenzyme
true
0
Polygon -2674135 true false 76 47 197 150 76 254 257 255 257 47
Polygon -10899396 true false 79 46 198 148 78 254

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

complex
false
0
Circle -1 true false 22 20 248
Circle -7500403 true true 83 81 122
Circle -16777216 true false 122 120 44

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

enzyme
true
0
Polygon -2674135 true false 76 47 197 150 76 254 257 255 257 47

epenzyme
true
0
Polygon -2674135 true false 76 47 197 150 76 254 257 255 257 47
Polygon -8630108 true false 79 46 198 148 78 254
Circle -1184463 false false 45 105 30
Circle -1184463 false false 45 135 30
Circle -1184463 false false 45 165 30

esenzyme
true
0
Polygon -2674135 true false 76 47 197 150 76 254 257 255 257 47
Polygon -10899396 true false 79 46 198 148 78 254

exenzyme
false
0
Circle -1 true false 22 20 248
Circle -7500403 true true 83 81 122
Circle -2674135 true false 122 120 44

eyeball
false
0
Circle -1 true false 22 20 248
Circle -7500403 true true 83 81 122
Circle -16777216 true false 122 120 44

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

molecule oxygen
true
0
Circle -7500403 true true 120 75 150
Circle -16777216 false false 120 75 150
Circle -7500403 true true 30 75 150
Circle -16777216 false false 30 75 150

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

product
true
0
Polygon -1184463 true false 150 5 40 250 150 205 260 250

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

substrate
true
0
Polygon -13840069 true false 150 5 40 250 150 205 260 250

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.3.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
