       program     S31GI
C
C Two-state-glucose-isomerase-enzyme-kinetic-scheme
C
CCCC  Values of rate constants, substrate and product conc are from Converti papers
C     in 1997 and 1988, and Doboviek-2017. Second order rate constants k1s and k4s
C     are expressed in inverse moles and inverse seconds.
C
C
       real*8  thermale,k1,k2,k3,k4,k1s,k4s,
     &   xsec,sigma,enprodB1,enprodB2,aX1,aX2,aXtot,
     &   ckonst4a(10000),ckonst1a(10000),
     &   keqk12L,keqk21D,sigmap,sigmab,enprodT,
     &   currB1,currB2,gaussrand2,gaussrand3,gaussrand4,
     &   sprob(4),entros(4),entrops,substrates,products,
     &   kcat,Km,Ktot,enzeff,s1,s2,pi,
     &   gaussrand1,ckonst2a(10000),ckonst3a(10000)
C
C
       aX1=0.0
       aX2=0.0
C
       aXtot=0.0
C
       enprodB1=0.0
       enprodB2=0.0
C
       sigmap=0.0
       sigmab=0.0
C
C
       k1=0.0
       k2=0.0
       k3=0.0
       k4=0.0
       k1s=0.0
       k4s=0.0
C
       keqk12L=0.0
       keqk21D=0.0
C
       currB1=0.0
       currB2=0.0
C
       thermale=0.0
       xsec=0.0
       sigma=0.0
       kcat=0.0
       Km=0.0
       enzeff=0.0
       Ktot=0.0
       mmm=0
       i=0
       entrops=0.0
C
       substrates=0.0
       products=0.0
C
       s1=0.0
       s2=0.0
       pi=0.0
C
       gaussrand1=0.0
       gaussrand2=0.0
       gaussrand3=0.0
       gaussrand4=0.0

       nnn=0
       jjj=0
C
       do 25 nnn=1,10000
        ckonst4a(nnn)=0.0
        ckonst3a(nnn)=0.0
        ckonst2a(nnn)=0.0
        ckonst1a(nnn)=0.0
25     continue
C
C
         pi=3.141592653589793
C
       substrates=2.0
C
        products=0.2
C
         thermale=2.8115355
C Corresponds to 65 C. Units are in kJ/mol
C
        k1s=0.063
C
        k1=k1s*substrates
C
        k2=0.021
C
        k3=0.029
C
        k4s=0.082
C
        k4=k4s*products
C
         kcat=k3
C
       keqk12L=k1/k2
C
       keqk21D=k3/k4
C
       Ktot=keqk12L*keqk21D
C
         Km=(k2+k3)/k1s
         enzeff=kcat/Km
C
         sigma=0.0
         sigmab=0.0
         sigmap=0.0
C 2-th state probability  p=1,b=2
         entrops=0.0
	   enprodB1=0.0
	   enprodB2=0.0
C
	   enprodT=0.0
C
           do 75 jj=1,2
         sprob(jj)=0.0
         entros(jj)=0.0
75       continue
C
         sigmap=k2+k3
C
         sigmab=k1+k4
C
         sigma=sigmap+sigmab
C
         sigmab=sigmab/sigma
C
         sigmap=sigmap/sigma
C
C
         sprob(1)=sigmab
C
         sprob(2)=sigmap
C
       do 750 mmmm=1,2
          entros(mmmm)=-sprob(mmmm)*2.3*dlog10(sprob(mmmm))
          entrops=entrops+entros(mmmm)
750    continue
C
C
        xsec=thermale*2.3025851*dlog10((k1*k3)/(k2*k4))
Cn all currents are without N (N=1)
Cn
        currB1=(k1*sigmap-k2*sigmab)
        currB2=(k3*sigmab-k4*sigmap)
C
          aX1=2.3025851*dlog10((k1*sigmap)/
     &   (k2*sigmab))
C
          aX2=2.3025851*dlog10((k3*sigmab)/
     &   (k4*sigmap))
C
          aXtot=aX1+aX2
C
Cn all "entropy productions" are TP expressions in TR units

        enprodB1=aX1*currB1
        enprodB2=aX2*currB2
C
C
        enprodT=enprodB1+enprodB2
C
        Ktot=keqk12L*keqk21D
C
            open (unit=11,status='unknown',file='S31GIexp.dat',
     & access='sequential',form='formatted')
       write(11,65)
65      format(2x,'        k1              k2                k3   ',
     &  '              k4     entropy        p1       p2    ',
     &  '      P1          P2         Ptot       ',
     &  '  kcat         Km            enzeff           J  ',
     &  '            xsec           Xtot            X1           X2 ')
C
        write(11,'(4(f16.6,1x),3(f10.7),4(f12.3),1x,7(f14.6,1x))')
     &  k1,k2,k3,k4,entrops,sigmap,sigmab,enprodB1,enprodB2,
     &  enprodT,kcat,Km,enzeff,currB1,xsec,aXtot,aX1,aX2
C
        close(unit=11)
C
            open (unit=9,status='unknown',file='S31GIrand.dat',
     & access='sequential',form='formatted')
       write(9,45)
45      format(2x,'   i     k1      k2       k3    ',
     &  '   k4     S(I)    p1    p2        P1   ',
     &  '    P2      Ptot    enzeff     kcat  ',
     &  '    Km         J        xsec  ',
     &  '    Xtot       X1         X2     Ktot   ',
     &  '      S         P       S+P')
C
        substrates=0.0
       products=0.0
C
        do 50 i=1,10000
C
       substrates=2.0
       products=0.2
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand1=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+1
C
        gaussrand2=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+1
C
        gaussrand3=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+1
C
        gaussrand4=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+1
C
        if (gaussrand2.gt.0) then
         ckonst2a(i)=0.021*gaussrand2
         k2=ckonst2a(i)
C
        endif
C
        if (gaussrand1.gt.0) then
         ckonst1a(i)=0.063*gaussrand1
         k1s=ckonst1a(i)
         k1=k1s*(substrates-i*0.00001)
C
        endif
C
        keqk12L=k1/k2
C
        if (gaussrand3.gt.0) then
        ckonst3a(i)=0.029*gaussrand3
        k3=ckonst3a(i)
        endif
C
        if (gaussrand4.gt.0) then
        ckonst4a(i)=0.082*gaussrand4
        k4s=ckonst4a(i)
        k4=k4s*(products+i*0.00001)
        endif
C
        keqk21D=k3/k4
C
        Ktot=keqk12L*keqk21D
C
        kcat=k3
        Km=(k2+k3)/k1s
        enzeff=kcat/Km
C
         sigma=0.0
         sigmab=0.0
         sigmap=0.0
C 2-th state probability  p=1,b=2
         entrops=0.0
	   enprodB1=0.0
	   enprodB2=0.0
C
	   enprodT=0.0
C
           do 55 jj=1,2
         sprob(jj)=0.0
         entros(jj)=0.0
55       continue
C
         sigmap=k2+k3
C
         sigmab=k1+k4
C
         sigma=sigmap+sigmab
C
         sigmab=sigmab/sigma
C
         sigmap=sigmap/sigma
C
         sigma=sigmap+sigmab
C
         sprob(1)=sigmab
C
         sprob(2)=sigmap
C
       do 700 mmmm=1,2
          entros(mmmm)=-sprob(mmmm)*2.3*dlog10(sprob(mmmm))
          entrops=entrops+entros(mmmm)
700    continue
C
C
         xsec=thermale*2.3025851*dlog10((k1*k3)/(k2*k4))
Cn all currents are without N (N=1)
Cn
        currB1=(k1*sigmap-k2*sigmab)
        currB2=(k3*sigmab-k4*sigmap)
C
          aX1=2.3025851*dlog10((k1*sigmap)/
     &   (k2*sigmab))
Cn
          aX2=2.3025851*dlog10((k3*sigmab)/
     &   (k4*sigmap))
Cn
C
          aXtot=aX1+aX2
C
Cn all "entropy productions" are TP expressions in RT units
Cn
        enprodB1=aX1*currB1
        enprodB2=aX2*currB2
C
        enprodT=enprodB1+enprodB2
C
C
        write(9,'(i6,4(f8.4,1x),3(f6.4,1x),4(f9.4),11(f10.4))')
     &  i,k1,k2,k3,k4,entrops,sigmap,sigmab,enprodB1,enprodB2,
     &  enprodT,enzeff,kcat,Km,currB1,xsec,aXtot,aX1,aX2,Ktot,
     &  substrates-i*0.00001,products+i*0.00001,substrates+products
C
 50    continue
C
       close(unit=9)
C
       stop
       end
C Author: Davor Juretic, year:2023, preprint:
C Computational Improvements of Enzyme Efficiency kcat/KM by Increasing Noise and Dissipation
C Submitted to the Entropy journal.
C Title: Theoretical Improvements in Enzyme Efficiency Associated with Noisy Rate Constants and Increased Dissipation
C This source code produce S31GIran.dat parameters for identical random changes
C in the rate constants k1, k2, k3, and k4. Change in the equilibrium constant Ktot and overall force X
C is due decreased substrate and increased product concentration.
C We then used the columns enprodT (named Ptot) and ENZeff (named Eff)
C to create figure S20 from Supplementary Materials. Parameters based on experiments are in a single row
C of S31GIexp.dat output.
C The run time should be around 11 sec.
C
