
!Author: Željana Bonačić Lošić, Year: 2023, Paper title: Computational Improvements of Enzyme Efficiency kcat/KM by Increasing Noise and Dissipation
!Flux J and entropy production as function of chemical affinity for 4 state TPI sheme (triosephosphate isomerase)

      double precision k1,k2,k3,k4,Kv1,Kv4,k1m,k2m,k3m,k4m,sigma12,sigma41,p1,p2,p3,p4,Kv2
      double precision sigma,b2m,b1,b4,b1m,a12,a41,S,S1,S2,S3,S4,signa23,sigma34,b3,b3m,a23
      double precision a34,b4m,J23,J41,J12,J34,X,X12,X23,X34,X41,SN,PN
      integer i
      character*15	 file1,file2

      write(*,1) 'Insert file name - flux'
      read(*,2) file1
      open(unit=11,file=file1,status='unknown',form='formatted')
      write(*,1) 'Insert file name - entropy production'
      read(*,2) file2
      open(unit=12,file=file2,status='unknown',form='formatted')
       PN=0.064

    do i=0,39
       PN=PN+i*0.05
     SN=40.064-PN
      k1=10.0*SN
        k2=2000.0
             k3=60000.0
        k4=4000.00

         k1m=7000.0
       k2m=6000.0
       k3m=90000.0
          k4m=25.60*PN/0.064

          Kv1=k1/k1m
          Kv2=k2/k2m
            Kv3=k3/k3m
              Kv4=k4/k4m
      a23=k3m*k4/Kv4+k1*k3m+k1*k4
       b2=k1*k3*k4
       b3m=k1*k4*k3m/(Kv1*Kv4)
       b2m=k4*k3m*k2m/Kv4
      b1=k2*k3*k4
       b4=k1*k2*k3
       b1m=k3m*k2m*k1/Kv1
        a12=k3*k4+k3m*k2m+k2m*k4
        a41=k2*k3+k1*(k3+k2m)/Kv1
        a34=k1*k2+k4*(k2+k1/Kv1)/Kv4
         b4m=k2m*k1*k4/(Kv1*Kv4)

          S1=k3m*k2m*k1m+k1m*k3*k4+k4*k2m*k1m+k2*k3*k4

          S2=k3*k4*k1+k4m*k3m*k2m+k1*k3m*k2m+k2m*k4*k1

          S3=k4*k1*k2+k1m*k4m*k3m+k4m*k3m*k2+k1*k2*k3m

            S4=k2m*k1m*k4m+k1*k2*k3+k4m*k2*k3+k1m*k4m*k3
          S=S1+S2+S3+S4

            p1=S1/S
           p2=S2/S
            p3=S3/S
           p4=S4/S

          sigma12=k1*((b1-b2m/Kv1)*dlog((Kv1*b1+k1*a12)/(b2m+k1*a12)))/S
          sigma23=k2*((b2-b3m/Kv2)*dlog((Kv2*b2+k2*a23)/(b3m+k2*a23)))/S
          sigma34=(k3*p3-k3m*p4)*dlog((k3*p3)/(k3m*p4))

              sigma41=(k4*p4-k4m*p1)*dlog((k4*p4)/(k4m*p1))

            J12=k1*(b1-b2m/Kv1)/S
            J23=k2*(b2-b3m/Kv2)/S
            J34=(k3*p3-k3m*p4)
            J41=(k4*p4-k4m*p1)
            X12=dlog((Kv1*b1+k1*a12)/(b2m+k1*a12))
            X23=dlog((Kv2*b2+k2*a23)/(b3m+k2*a23))
            X34=dlog((k3*p3)/(k3m*p4))
            X41=dlog((k4*p4)/(k4m*p1))
            X=X12+X23+X34+X41

         sigma=J12*X12+J23*X23+J34*X34+J41*X41

     write(11,*) X,J12
     write(12,*) X,sigma
     enddo
        close(11)
        close(12)
1	format(1X,A)
2	format(A)
99	format(f15.6,2X,f15.6)

      end

